//------------------------------------------------------------------
#property copyright "mladen"
#property link      "mladenfx@gmail.com"
//------------------------------------------------------------------
#property indicator_separate_window
#property indicator_buffers    3
#property indicator_color1     Blue
#property indicator_color2     Magenta
#property indicator_color3     DarkSlateGray
#property indicator_width1     2
#property indicator_width2     2
#property indicator_width3     2
#property indicator_maximum    1
#property indicator_minimum    -1
#property indicator_levelcolor DarkGray

//
//
//
//
//

extern int    Length                     = 21;
extern int    Price                      = PRICE_CLOSE;
extern double levelOs                    = -0.5;
extern double levelOb                    = 0.5;

extern bool   alertsOn                   = true;
extern bool   alertsOnSlope              = false;
extern bool   alertsOnZeroCross          = true;
extern bool   alertsOnLeavingObOs        = false;
extern bool   alertsOnCurrent            = true;
extern bool   alertsMessage              = true;
extern bool   alertsSound                = false;
extern bool   alertsEmail                = false;
extern bool   alertsPush                 = false;
extern string soundFile                  = "alert2.wav"; 

extern bool   arrowsVisible              = true;
extern bool   arrowsOnSlope              = true;
extern color  arrowsOnSlopeUpColor       = LimeGreen;
extern color  arrowsOnSlopeDnColor       = Red;
extern int    arrowsOnSlopeUpCode        = 241;
extern int    arrowsOnSlopeDnCode        = 242;
extern int    arrowsOnSlopeSize          = 2;

extern bool   arrowsOnZeroCross          = true;
extern color  arrowsOnZeroCrossUpColor   = DeepSkyBlue;
extern color  arrowsOnZeroCrossDnColor   = PaleVioletRed;
extern int    arrowsOnZeroCrossUpCode    = 159;
extern int    arrowsOnZeroCrossDnCode    = 159;
extern int    arrowsOnZeroCrossSize      = 5;

extern bool   arrowsOnLeavingObOs        = true;
extern color  arrowsOnLeavingObOsUpColor = DodgerBlue;
extern color  arrowsOnLeavingObOsDnColor = OrangeRed;
extern int    arrowsOnLeavingObOsUpCode  = 241;
extern int    arrowsOnLeavingObOsDnCode  = 242;
extern int    arrowsOnLeavingObOsSize    = 3;

extern string arrowsIdentifier           = "3c rsx arrows1";
extern double arrowsUpperGap             = 1.0;
extern double arrowsLowerGap             = 1.0;

//
//
//
//
//

double rsx[];
double rsxDa[];
double rsxDb[];
double slope[];
double trend1[];
double trend2[];

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorBuffers(6);
      SetIndexBuffer(0,rsxDa); SetIndexStyle(0,DRAW_HISTOGRAM);
      SetIndexBuffer(1,rsxDb); SetIndexStyle(1,DRAW_HISTOGRAM);
      SetIndexBuffer(2,rsx);
      SetIndexBuffer(3,slope);
      SetIndexBuffer(4,trend1);
      SetIndexBuffer(5,trend2);
      SetLevelValue(0,levelOb);
      SetLevelValue(1,levelOs);
      SetLevelValue(2,0);
   IndicatorShortName("Rsx ("+Length+")");
return(0);
}
int deinit() 
{ 
   deleteArrows();
   
return(0); 
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

double wrkBuffer[][13];

int start()
{
   int i,r,counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);
         if (ArrayRange(wrkBuffer,0) != Bars) ArrayResize(wrkBuffer,Bars);

   //
   //
   //
   //
   //
   
   double Kg = (3.0)/(2.0+Length); 
   double Hg = 1.0-Kg;
   for(i=limit, r=Bars-i-1; i>=0; i--, r++)
   {
      wrkBuffer[r][12] = iMA(NULL,0,1,0,MODE_SMA,Price,i);
      if (i==(Bars-1)) { for (int c=0; c<12; c++) wrkBuffer[r][c] = 0; continue; }  

      //
      //
      //
      //
      //
      
      double mom = wrkBuffer[r][12]-wrkBuffer[r-1][12];
      double moa = MathAbs(mom);
      for (int k=0; k<3; k++)
      {
         int kk = k*2;
            wrkBuffer[r][kk+0] = Kg*mom                + Hg*wrkBuffer[r-1][kk+0];
            wrkBuffer[r][kk+1] = Kg*wrkBuffer[r][kk+0] + Hg*wrkBuffer[r-1][kk+1]; mom = 1.5*wrkBuffer[r][kk+0] - 0.5 * wrkBuffer[r][kk+1];
            wrkBuffer[r][kk+6] = Kg*moa                + Hg*wrkBuffer[r-1][kk+6];
            wrkBuffer[r][kk+7] = Kg*wrkBuffer[r][kk+6] + Hg*wrkBuffer[r-1][kk+7]; moa = 1.5*wrkBuffer[r][kk+6] - 0.5 * wrkBuffer[r][kk+7];
      }
      if (moa != 0)
           rsx[i] = MathMax(MathMin((mom/moa+1.0)*50.0,100.00),0.00)/(50)-1; 
      else rsx[i] = 0;
      
      //
      //
      //
      //
      //
      
      rsxDa[i]  = EMPTY_VALUE;
      rsxDb[i]  = EMPTY_VALUE;
      slope[i]  = slope[i+1];
      trend1[i] = trend1[i+1];
      trend2[i] = trend2[i+1];
         if (rsx[i] > rsx[i+1]) slope[i]  = 1;
         if (rsx[i] < rsx[i+1]) slope[i]  =-1;
         if (rsx[i] > 0)        trend1[i] = 1; 
         if (rsx[i] < 0)        trend1[i] =-1;
         if (rsx[i] > levelOb)  trend2[i] = 1;
         if (rsx[i] < levelOs)  trend2[i] =-1; 
         if (slope[i] == 1)     rsxDa[i]  = rsx[i];
         if (slope[i] ==-1)     rsxDb[i]  = rsx[i];
         manageArrow(i);
   }
   manageAlerts();
return(0);
}

//
//
//
//
//

void manageArrow(int i)
{
   if (arrowsVisible)
   {
      deleteArrow(arrowsIdentifier+":1a"+Time[i]);
      deleteArrow(arrowsIdentifier+":2a"+Time[i]);
      deleteArrow(arrowsIdentifier+":3a"+Time[i]);
      if (arrowsOnSlope && slope[i] != slope[i+1])
      {
         if (slope[i] == 1) drawArrow("11",i,arrowsOnSlopeUpColor,arrowsOnSlopeUpCode,arrowsOnSlopeSize,false);
         if (slope[i] ==-1) drawArrow("11",i,arrowsOnSlopeDnColor,arrowsOnSlopeDnCode,arrowsOnSlopeSize, true);
      } 
      if (arrowsOnZeroCross && trend1[i] != trend1[i+1])
      {
         if (trend1[i] == 1) drawArrow("22",i,arrowsOnZeroCrossUpColor,arrowsOnZeroCrossUpCode,arrowsOnZeroCrossSize,false);
         if (trend1[i] ==-1) drawArrow("22",i,arrowsOnZeroCrossDnColor,arrowsOnZeroCrossDnCode,arrowsOnZeroCrossSize, true);
      }
      if (arrowsOnLeavingObOs && trend2[i] != trend2[i+1])
      {
         if (trend2[i+1] == -1 && trend2[i] !=-1) drawArrow("33",i,arrowsOnLeavingObOsUpColor,arrowsOnLeavingObOsUpCode,arrowsOnLeavingObOsSize,false);
         if (trend2[i+1] ==  1 && trend2[i] != 1) drawArrow("33",i,arrowsOnLeavingObOsDnColor,arrowsOnLeavingObOsDnCode,arrowsOnLeavingObOsSize, true);
      }                                  
   }         
}       

//
//
//
//
//

void drawArrow(string add, int i,color theColor,int theCode,int theSize, bool up)
{
   string name = arrowsIdentifier+":"+add+Time[i];
   double gap  = iATR(NULL,0,20,i);   
   
      //
      //
      //
      //
      //
      
      ObjectCreate(name,OBJ_ARROW,0,Time[i],0);
         ObjectSet(name,OBJPROP_ARROWCODE,theCode);
         ObjectSet(name,OBJPROP_COLOR,   theColor);
         ObjectSet(name,OBJPROP_WIDTH,    theSize);      
         
         if (up)
               ObjectSet(name,OBJPROP_PRICE1,High[i] + arrowsUpperGap * gap);
         else  ObjectSet(name,OBJPROP_PRICE1, Low[i] - arrowsLowerGap * gap);
}

//
//
//
//
//

void deleteArrows()
{
   string lookFor       = arrowsIdentifier+":";
   int    lookForLength = StringLen(lookFor);
   for (int i=ObjectsTotal()-1; i>=0; i--)
   {
      string objectName = ObjectName(i);
         if (StringSubstr(objectName,0,lookForLength) == lookFor) ObjectDelete(objectName);
   }
}

//
//
//
//
//

void deleteArrow(datetime time)
{
   string lookFor = arrowsIdentifier+":"+time; ObjectDelete(lookFor);
}


//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

void manageAlerts()
{
   if (alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1;
      
      //
      //
      //
      //
      //
      
      static datetime time1 = 0;
      static string   mess1 = "";
         if (alertsOnSlope && slope[whichBar] != slope[whichBar+1])
         {
            if (slope[whichBar] ==  1) doAlert(time1,mess1,whichBar," sloping up ");
            if (slope[whichBar] == -1) doAlert(time1,mess1,whichBar," sloping down ");
         }            
      static datetime time2 = 0;
      static string   mess2 = "";
         if (alertsOnZeroCross && trend1[whichBar] != trend1[whichBar+1])
         {
            if (trend1[whichBar] ==  1) doAlert(time2,mess2,whichBar," crossing zero up ");
            if (trend1[whichBar] == -1) doAlert(time2,mess2,whichBar," crossing zero down ");
         } 
      static datetime time3 = 0;
      static string   mess3 = "";
         if (alertsOnLeavingObOs && trend2[whichBar] != trend2[whichBar+1])
         {
            if (trend2[whichBar+1] == -1 && trend2[whichBar] !=-1) doAlert(time3,mess3,whichBar," leaving oversold zone ");
            if (trend2[whichBar+1] ==  1 && trend2[whichBar] != 1) doAlert(time3,mess3,whichBar," leaving overbought zone ");
         }                       
   }
}   

//
//
//
//
//

void doAlert(datetime& previousTime, string& previousAlert, int forBar, string doWhat)
{
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[forBar]) {
          previousAlert  = doWhat;
          previousTime   = Time[forBar];

          //
          //
          //
          //
          //

          message =  Symbol()+" at "+TimeToStr(TimeLocal(),TIME_SECONDS)+" 3c_Rsx histo "+doWhat;
             if (alertsMessage) Alert(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol()," 3c_Rsx histo "),message);
             if (alertsPush)    SendNotification(StringConcatenate(Symbol(), Period() ," 3c_Rsx histo " +" "+message));
             if (alertsSound)   PlaySound("alert2.wav");
      }
}